/***************************************************************************
 *   Copyright (C) 2007 by Chunkeey <chunkeey@web.de>                      *
 *   Copyright (C) 2008 by Jung-uk Kim <jkim@FreeBSD.org>                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __ASUSOLED_H__
#define __ASUSOLED_H__

#define	DISPLAY_ON	0x0001
#define	DISPLAY_OFF	0x0002
#define DISPLAY_BLANK	0x0004
#define	DISPLAY_FILL	0x0008

#define	DRAW_STATIC	0x0001
#define	DRAW_FLASH	0x0002
#define	DRAW_ROLL	0x0004
#define	DRAW_EMASK	(DRAW_FLASH | DRAW_ROLL)
#define	DRAW_EFFECT(f)	(f & DRAW_EMASK)

#define	DRAW_NEGATE	0x0010
#define	DRAW_REVERSE	0x0020
#define	DRAW_FLIP	0x0040
#define	DRAW_CMASK	(DRAW_NEGATE | DRAW_REVERSE | DRAW_FLIP)
#define	DRAW_CONVERT(f)	(f & DRAW_CMASK)

struct usb_device *oled_find_device(void);
struct usb_dev_handle *oled_open(struct usb_device *);
int	oled_close(struct usb_dev_handle *);
int	oled_control(struct usb_dev_handle *, int);
int	oled_draw_image(struct usb_dev_handle *, int, int, int,
	    const unsigned char *);

#endif
