/***************************************************************************
 *   Copyright (C) 2007 by Chunkeey <chunkeey@web.de>                      *
 *   Copyright (C) 2008 by Jung-uk Kim <jkim@FreeBSD.org>                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __ASUSOLED_HW_H__
#define __ASUSOLED_HW_H__

#define FILL_HEADER(head, val1, val2, val3, val4, val5, val6, val7)	\
    do {			\
	memset(&head, 0, 16);	\
	head.magic = 0xaa55;	\
	head.flags = val1;	\
	head.value3 = val2;	\
	head.buffer1 = val3;	\
	head.buffer2 = val4;	\
	head.value6 = val5;	\
	head.value7 = val6;	\
	head.value8 = val7;	\
    } while(0);

struct oled_header {
	unsigned short magic;
	unsigned char flags;
	unsigned char value3;
	unsigned char buffer1;
	unsigned char buffer2;
	unsigned char value6;
	unsigned char value7;
	unsigned char value8;
	unsigned char padding2[7];
} __attribute((packed));

struct oled_packet {
	struct oled_header header;
	unsigned char bitmap[256];
} __attribute((packed));

#endif
